<template>
  <div>
    <modal-new-variant
      :menuBaseId="idMenuSelected"
    >
    </modal-new-variant>

    <modal-new-menu></modal-new-menu>

    <div class="row">
      <div class="ui buttons">
        <button
          class="ui button"
        >
           {{ count > 1 ? 'Menus' : 'Menu' }}
        </button>
        <div
          class="or"
          :data-text="count"
        ></div>
        <button
          class="ui positive button"
          @click="openModalNewMenu"
        >
          Ajouter
        </button>
      </div>
    </div>
    <br/>

    <dropdown-menus
      @menuChanged="menuChanged"
    >
    </dropdown-menus>
    <br/>

    <div
      v-if="idMenuSelected !== ''"
      class="ui button"
      @click="removeMenu"
    >
      <i class="ui red trash icon"></i>
      Supprimer ce menu
    </div>
    <br/>

    <menu-variants
      v-if="idMenuSelected !== '' && menuVariantsCount > 0"
      :variants="menuVariants"
      :menuBaseId="idMenuSelected"
      @removeVariant="removeVariant"
    >
    </menu-variants>

    <h3 v-if="idMenuSelected !== '' && menuVariantsCount === 0">
      Pas de variante pour ce menu
    </h3>

    <div
      v-if="idMenuSelected !== ''"
      class="ui positive icon button"
      @click="openModalNewVariant"
    >
      Ajouter nouvelle variante
    </div>
    <br/>

  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import store from '@/store/Store'
import MenusStore from '@/store/modules/menus/MenusStore'
import DropdownMenus from './DropdownMenus'
import MenuVariants from './MenuVariants'
import ModalNewMenu from './ModalNewMenu'
import ModalNewVariant from './ModalNewVariant'

export default {
  name: 'Menus',
  store,
  data () {
    return {
      idMenuSelected: ''
    }
  },
  mounted () {
    if (MenusStore.getters.count(MenusStore.state) === 0) {
      store.dispatch('MenusStore/loadMenus')
        .then(
          (response) => {
          },
          (error) => {
            this.$toastr.e(error.response.data.message)
          }
        )
    }
  },
  methods: {
    menuChanged (idMenu) {
      this.idMenuSelected = idMenu
      store.dispatch('MenuVariantsStore/loadMenuVariantsOfMenu', idMenu)
        .then(
          (response) => {
          },
          (error) => {
            this.$toastr.e(error.response.data.message)
          }
        )
    },
    removeMenu () {
      store.dispatch('MenusStore/removeMenu', this.idMenuSelected)
        .then((response) => {
          this.$toastr.s('Bien supprimé')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    removeVariant (id) {
      store.dispatch('MenuVariantsStore/removeMenuVariant', id)
        .then((response) => {
          this.$toastr.s('Bien supprimée')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    openModalNewMenu () {
      // eslint-disable-next-line
      $('#new-menu-modal')
        .modal('show')
    },
    openModalNewVariant () {
      // eslint-disable-next-line
      $('#new-variant-modal')
        .modal('show')
    }
  },
  computed: {
    ...mapGetters({
      count: 'MenusStore/count',
      menuVariants: 'MenuVariantsStore/menuVariants',
      menuVariantsCount: 'MenuVariantsStore/count'
    })
  },
  components: {
    DropdownMenus,
    MenuVariants,
    ModalNewMenu,
    ModalNewVariant
  }
}
</script>
